package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.DataPemeriksaanPraKerja;
import com.jasamedika.medifirst2000.vo.DataPemeriksaanPraKerjaVO;

@Component
public class DataPemeriksaanPraKerjaConverter implements BaseVoConverter<DataPemeriksaanPraKerjaVO, DataPemeriksaanPraKerja> {


	@Override
	public DataPemeriksaanPraKerja transferVOToModel(DataPemeriksaanPraKerjaVO vo, DataPemeriksaanPraKerja model) {
		if (null == model)
			model = new DataPemeriksaanPraKerja();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, DataPemeriksaanPraKerja.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<DataPemeriksaanPraKerjaVO> transferListOfModelToListOfVO(List<DataPemeriksaanPraKerja> models, List<DataPemeriksaanPraKerjaVO> vos) {

		if (null == vos)
			vos = new ArrayList<DataPemeriksaanPraKerjaVO>();

		if (null == models)
			return vos;

		for (DataPemeriksaanPraKerja DataPemeriksaanPraKerja : models) {
			DataPemeriksaanPraKerjaVO vo = new DataPemeriksaanPraKerjaVO();
			vo=transferModelToVO(DataPemeriksaanPraKerja, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public DataPemeriksaanPraKerjaVO transferModelToVO(DataPemeriksaanPraKerja model, DataPemeriksaanPraKerjaVO vo) {
		if (null == vo)
			vo = new DataPemeriksaanPraKerjaVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
	        Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, DataPemeriksaanPraKerjaVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
}
